import java.io.IOException;
import java.io.*;


class MergeSort {
  public static void mergeSort(double tab[]) {
    double tab1[]=new double[tab.length];
    mergeSort(tab, 0, tab.length-1, tab1);
  }

  private static void mergeSort(double tab[], int i1, int i2,
       double tab1[]) {
   if((i2-i1)>1) { // se imparte in doua subzone
     int k=(i1+i2)/2; // mijlocul intervalului
     /* Se sorteaza separat cele doua jumatati ale zonei (i1,i2),
        folosind tab1 ca tablou auxiliar si obtinand rezultatele
        in tab
     */
     mergeSort(tab,i1,k-1,tab1); // sortare subzona stanga
     mergeSort(tab, k,i2, tab1); // sortare subzona dreapta
     /* Se interclaseaza cele doua subzone, folosind tabloul 
        auxiliar tab1 si obtinand rezultatul in tab
     */
     interclasare(tab,i1, k, i2, tab1);
   }
   else { // au ramas cel mult doua elemente
     if((i2-i1)==1){// se ordoneaza cele doua elemente
       if(tab[i1]>tab[i2]) { // interschimbarea elementelor
         double aux=tab[i1];
         tab[i1]=tab[i2];
         tab[i2]=aux;
       } // sfarsit if
     }  // sfarsit if
   }  // sfarsit else
  } // sfarsit metoda

  private static void interclasare(double tab[], int i1, int k, 
      int i2, double tab1[]) {
    int i=i1, j=k, q=i1;
    while(i<k && j<=i2) {
      if(tab[i]<tab[j]) tab1[q++]=tab[i++];
      else tab1[q++]=tab[j++];
    } // sfarsit while
    while(i<k) tab1[q++]=tab[i++];
    while(j<=i2) tab1[q++]=tab[j++];
    for(q=i1; q<=i2; q++) tab[q]=tab1[q]; // mutare din tab1 in tab
  } // sfarsit metoda

  /* Testarea metodelor */
  public static void main(String args[]) {
    double tab[]=new double[10], 
           tab1[]=new double[10];
    for(int i=0; i<10; i++) {
    try {
     	tab[i] = (double) (System.in.read() - '0');	
    	}
     	catch (IOException e){
      System.out.println("Error reading from user");
    }
    System.out.println(i+"  ");
}
  //    tab[i]=Double.parseDouble(args[i]);
    mergeSort(tab);
    System.out.println("Tabloul sortat:");
    for(int i=0; i<tab.length; i++)
      System.out.print(tab[i]+" ");
    System.out.println();
  } // sfarsit main
}

