class QuickSort {
  /* Metoda publica prin care se sorteaza tabloul tab[] */
  public static void quickSort(double tab[]) {
    if (tab==null || tab.length==0) return;
    quickSort(tab, 0, tab.length-1);
  }

  /* Metoda auxiliara privata, prin care se sorteaza o zona din
     tab cuprinsa intre indicii i1 si i2 (inclusiv) 
  */
  private static void quickSort(double tab[], int i1, int i2) {
    int i=i1, j=i2, p=(i1+i2)/2;
    double pivot=tab[p], aux;
    /* interschimbarea componentelor */
    while(i<j) {
      /* se cauta in partea stanga o componenta mai mare decat pivotul
         si in partea dreapta o componenta mai mica decat acesta
      */
      while(tab[i]<pivot) i++;
      while(tab[j]>pivot) j--;
      /* daca i<j, se face interscimbarea componentelor de pe 
         pozitiile i si j
      */
      if(i<j) {
        aux=tab[i];
        tab[i]=tab[j];
        tab[j]=aux;
      } // sfarsit if
      if(i<=j) {
        i++; j--; // se cauta in continuare
      } // sfarsit if
    } // sfarsit while
    /* Acum in zona i1 .. j sunt elemente mai mici decat pivotul,
       iar in zona i .. i2 sunt elemente mai mari decat pivotul
       si (i>j).
       Se aplica recursiv metoda de sortare pentru fiecare din aceste
       doua zone.
    */
    if(i1<j) quickSort(tab, i1, j);
    if(i<i2) quickSort(tab, i, i2);
  } // sfarsit metoda

  /* Testarea metodei quickSort */
  public static void main(String args[]) {
    if(args.length==0) {
      System.out.println("Dati ca argument in linia de comanda "+
        "tabloul de sortat");
      System.exit(0);
    }
    double tab[]=new double[args.length];
    for(int i=0; i<tab.length; i++) tab[i]=Double.parseDouble(args[i]);
    quickSort(tab); // invocarea metodei de sortare rapida
    System.out.println("Tabloul sortat:");
    for(int i=0; i<tab.length; i++) System.out.print(tab[i]+" ");
    System.out.println();
  }
}

    