/* Clasa LinkedStack reprezinta o stiva implementata printr-o
   lista inlantuita din clasa LinkedList. Varful stivei este 
   plasat in capul listei. Metodele sunt cele specifice stivei:
    - push - se pune un element in stiva;
    - pop - se extrage un element din stiva;
    - peek - se viziteaza elementul din varful stivei, fara a-l
             extrage;
    - search - se cauta un obiect in stiva.
*/

import java.util.*;

class LinkedStack {
  private LinkedList lista=new LinkedList();
  
  public Object push(Object item) {
    if(item!=null)
      lista.addFirst(item);
    return item;
  }

  public Object pop() {
    return lista.removeFirst();
  }
  
  public Object peek() {
    return lista.getFirst();
  }

  public boolean empty() {
    return lista.isEmpty();
  }

  public int search(Object obj) {
    int adancime=lista.indexOf(obj);
    if(adancime>-1) adancime++;
    return adancime;
  }

  public String toString() {
    return lista.toString();
  }
}

/* Aplicatia de testare a stivei. Se pune in executie sub forma
    java TestLinkedStack <argumente>
   unde argumentele sunt niste siruri care vor fi puse in stiva
   si apoi afisate in ordine inversa
*/

class TestLinkedStack {
  public static void main(String args[]) {
    if(args.length==0) {
      System.out.println("Dati in linia de comanda niste siruri");
      System.exit(0);
    }
    LinkedStack stiva=new LinkedStack();
    for(int i=0; i<args.length; i++) stiva.push(args[i]);
    System.out.println("Dupa incarcare stiva contine:\n"+stiva);
    System.out.println("Adancimea elementului \""+args[0]+
      "\" este " + stiva.search(args[0]));
    System.out.println("Elementele in ordinea scoaterii din stiva:");
    while(!stiva.empty()) 
      System.out.print("\""+stiva.pop()+"\" ");
    System.out.println();
  }
}

    