/* Program de testare a clasei ArboreSelectie

   La punerea in executie a programului se da in linia de comanda
   un sir de prioritati, de exemplu
    java TestAS 34 12 76 2 85 4 99 73 16 45 81 122 6

   Nodurile arborelui vor fi perechi (prioritate, element), in care
   ca element se foloseste un obiect al clasei acoperitoare Integer,
   care contine numarul sau in ordinea introducerii.

   Daca prioritatea data este zero sau negativa, in loc de punere a
   unui element in coada, are loc o extragere. De fiecare data se
   afiseaza noul arbore de selectie obtinut.

   La sfarsit, se extrag din coada toate elementele ramase si se 
   afiseaza valorile lor (nu prioritatile).
*/

class TestAS {
  public static void main(String args[]) {
    ArboreSelectie as=new ArboreSelectie();
    int prioritate;
    Object element;
    try {
      for(int i=0; i<args.length; i++) {
        prioritate=Integer.parseInt(args[i]);
        if(prioritate>0) {
          element=new Integer(i);
          as.put(element, prioritate);
          System.out.println("Pus "+element+" coada: "+as);
        }
        else {
          element=as.remove();
          System.out.println("Scos "+element+" coada: "+as);
        }
      }
    }
    catch(Exception e) {
      System.out.println("Eroare in linia de comanda\n"+e);
      System.exit(0);
    }
    System.out.println("In final coada contine: "+as);
    System.out.println("Scoatere din coada: ");
    while(as.size()>0)
      System.out.print(as.remove() + " ");
    System.out.println();
  }
}
