import java.util.Iterator;
import java.io.*;

class TestGraf {
  public static void main(String args[]) {
    Graf graf=new Graf();
    graf.puneVarf("A","a");
    graf.puneVarf("B","b");
    graf.puneVarf("A","a"); // repetare
    graf.puneVarf("C","c");
    graf.puneArc("A","B","ab");
    graf.puneArc("A","A","aa");
    graf.puneArc("A","C","ac");
    graf.puneArc("C","A","ca");
    graf.puneArc("C","B","cb");
    graf.puneArc("A","C","ac"); // repetare
    graf.puneArc("B", "A","ba");
    System.out.println(graf);
    graf.eliminaArc("C","A");
    System.out.println(graf);
    graf.eliminaVarf("B");
    System.out.println(graf);
    graf.puneVarf("E","e");
    graf.puneVarf("B", "b");
    graf.puneVarf("D","d");
    graf.puneArc("A", "B", "ab");
    graf.puneArc("B","A","ba");
    graf.puneArc("B","D","bd");
    graf.puneArc("C","B","cb");
    graf.puneArc("C","D","cd");
    graf.puneArc("C","E","ce");
    graf.puneArc("D","B","db");
    graf.puneArc("D","E","de");
    graf.puneArc("E","C","ec");
    System.out.println(graf);
    System.out.println("Contine varf B: "+graf.contineVarf("B"));
    System.out.println("Contine varf X: "+graf.contineVarf("X"));
    System.out.println("informatia din varful B: "+
             graf.infoVarf("B"));
    System.out.println("informatia din varful X: "+
             graf.infoVarf("X"));
    System.out.println("Contine arc D-B: "+graf.contineArc("D","B"));
    System.out.println("Contine arc X-B: "+graf.contineArc("X","B"));
    System.out.println("Contine arc D-Y: "+graf.contineArc("D","Y"));
    System.out.println("Contine arc X-Y: "+graf.contineArc("X","Y"));
    System.out.println("Arcul D-B contine: "+graf.infoArc("D","B"));
    System.out.print("Pentru a continua, apasati tasta <Enter>");
    try {
      System.in.read();
    }
    catch(IOException e) {}
    Iterator iter=graf.iteratorLatime("A");
    if(iter==null) System.out.println("Iterator nul!");
    else {
      System.out.print("Explorare in latime: ");
      while(iter.hasNext())
        System.out.print(((Graf.Varf)iter.next()).eticheta()+" ");
      System.out.println();
    }
    iter=graf.iteratorLatime("E");
    if(iter==null) System.out.println("Iterator nul!");
    else {
      System.out.print("Explorare in latime: ");
      while(iter.hasNext())
        System.out.print(((Graf.Varf)iter.next()).eticheta()+" ");
      System.out.println();
    }
    iter=graf.iteratorAdancime("A");
    if(iter==null) System.out.println("Iterator nul!");
    else {
      System.out.print("Explorare in adancime: ");
      while(iter.hasNext()) {
        System.out.print(((Graf.Varf)iter.next()).eticheta()+" ");
      }
      System.out.println();
    }
    iter=graf.iteratorAdancime("E");
    if(iter==null) System.out.println("Iterator nul!");
    else {
      System.out.print("Explorare in adancime: ");
      while(iter.hasNext())
        System.out.print(((Graf.Varf)iter.next()).eticheta()+" ");
      System.out.println();
    }
    iter=graf.iteratorAdancime("B");
    if(iter==null) System.out.println("Iterator nul!");
    else {
      System.out.print("Explorare in adancime: ");
      while(iter.hasNext())
        System.out.print(((Graf.Varf)iter.next()).eticheta()+" ");
      System.out.println();
    }
    iter=graf.iteratorAdancime("C");
    if(iter==null) System.out.println("Iterator nul!");
    else {
      System.out.print("Explorare in adancime: ");
      while(iter.hasNext())
        System.out.print(((Graf.Varf)iter.next()).eticheta()+" ");
      System.out.println();
    }    
    System.out.println("Lista explorare latime:\n"+
        graf.explorareLatime("D"));
    System.out.println("Lista explorare adancime:\n"+
        graf.explorareAdancime("D"));
    Object iva=graf.puneInfoVarf("A","alpha");
    Object ivab=graf.puneInfoArc("A","B","beta");
    System.out.println("Dupa modificarea informatiei din varful A "+
      "infoVechi="+iva+"; info="+graf.infoVarf("A"));
    System.out.println("In arcul A-B infoVechi="+ivab+
      "; info="+graf.infoArc("A","B"));
    /* Scrierea pe disc a grafului */
    try {
      FileOutputStream fout=new FileOutputStream("Graf.dat");
      ObjectOutputStream objout=new ObjectOutputStream(fout);
      objout.writeObject(graf);
      System.out.println("Graful a fost salvat in fisierul Graf.dat");
      objout.close();
      System.in.skip(100);
      System.out.println("Pentru continuare apasati tasta <Enter>");
      System.in.read();
      FileInputStream fin=new FileInputStream("Graf.dat");
      ObjectInputStream objin=new ObjectInputStream(fin);
      graf=(Graf)objin.readObject();
      System.out.println("Graful citit din fisier:\n"+graf);
    }
    catch(Exception e) {
      System.out.println(e);
    }

  }
}
